#ifndef WAV_ICM_INCLUDED
#define WAV_ICM_INCLUDED

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../include/tomo_defs.h"
#include "../ansi_lib_loc/allocate.h"
#include "../ansi_lib_loc/invert.h"
#include "../ansi_lib_loc/solve2.h"

double wav_ICMstep(struct wavICMdata *wICMdata,struct all_data *data,double *S,struct column *sp_col,int *FLAG);

int wav_compute_derivatives(struct wavICMdata *wICMdata, struct all_data *data, struct column *sp_col,double *S);
double wav_calc_prior(struct all_data *data,struct geom_info *geom,int recon_lev);
double wav_pixel_prior(double *V,struct wavICMdata *wICMdata);


void circ_boundary_conds(int *ic, int *jc, int i, int j, int N, int M);
void  f_pro(double *S,struct all_data *data,struct geom_info *geom,double **profiles,struct column *sp_col, int lev);
void imgcoord(int *out_i,int *out_j,int s,int iter,int N,int M);
void updateS(double *S, struct column *sp_col, double diff);

#endif
