#ifndef WAV_TRANSFORM_INC
#define WAV_TRANSFORM_INC

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../ansi_lib_loc/allocate.h"
#include "../include/tomo_defs.h"


#define WAV_DC_DECOMP_MULT 0.5
#define WAV_DC_RECON_MULT 0.5

void wavelet_decomposition(double ****Z,double ***dc,double **Xin,struct geom_info *geom, int recon_lev);
void wavelet_transpose_decomposition(double **X,double ****Z,double ***dc_mr,struct geom_info *geom, int recon_lev);
void wavelet_reconstruction(double **X,double ****Z,double ***dc_mr,struct geom_info *geom);

void wavelet_reconstruction_trdc(double ***X,double ****Z,double ***tr_dc_mr,struct geom_info *geom);
void wav_copy_DC(double ***X,int level_fine,struct geom_info *geom);
void calc_Z_dir(double **Z_dir,int **Z_coord,int i,int j,int recon_lev);


#endif
