#ifndef INC_AGT_CLUST
#define INC_AGT_CLUST

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../ansi_lib_loc/allocate.h"
#include "../ansi_lib_loc/randlib.h"
#include "../include/agtree.h"

int determine_cluster(double *xvec, int x_len, struct node *clust, struct cmds *params);
void classifyData(struct node *clust, struct data *train, struct cmds *params, int nb_iter);
void cluster_data(int *clustered_data, struct node *clust, struct data *train, struct cmds *params);
double dist(double *vec1, double *vec2, int len);
void initClmeans(struct node *clust, struct data *train, struct cmds *params);
void test_trset_size(struct data *train, struct cmds *params);


#endif
