#ifndef AGT_MAIN_INC
#define AGT_MAIN_INC


#include <stdio.h>
#include <math.h>
#include <string.h>
#include "../ansi_lib_loc/allocate.h"
#include "../ansi_lib_loc/randlib.h"
#include "../ansi_lib_loc/invert.h"
#include "../ansi_lib_loc/heap.h"
#include "../ansi_lib_loc/pseudoinvert.h"
#include "../include/agt_matrixutils.h"
#include "../include/agt_io.h"
#include "../include/agt_alloc.h"
#include "../include/agt_clust.h"
#include "../include/agt_tree.h"
#include "../include/agt_filter.h"
#include "../include/agt_prune.h"
#include "../include/agt_calcerr.h"
#include "../include/agt_merge.h"
#include "../include/agt_var.h"
#include "../include/agtree.h"



struct node* vq(struct data *train, struct cmds *params);
double** predictTrain(struct node *clust,struct data *train, struct cmds *params);

/* Routine below implemented in agt_main.c but exported in
   agtree.h, thus commented out here */
/* void make_agtree(struct cmds *params);*/


#endif
