#!/bin/sh

# As example 1, but specify ground_truth file and -d option.
# This results in the same reconstruction as in example_1,
# but the output file will contain the full wavelet decomposition
# of the reconstruction and ground truth as well as 
# the conditional means for each scale obtained
# from the nonlinear predictors (Xip) and the prediction
# covariance information (Zivar)


cd ..
bin/tomo -s 1.0 -w 0.0 -i 10 -d -t EXAMPLE/data/mri_truth_m.mat EXAMPLE/data/mri_sino_m.mat EXAMPLE/data/mri_mask_m.mat EXAMPLE/mri_recon_ex2.mat


